package com.ssm.model.system;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class SysDepartmentExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public SysDepartmentExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andDepidIsNull() {
            addCriterion("DepID is null");
            return (Criteria) this;
        }

        public Criteria andDepidIsNotNull() {
            addCriterion("DepID is not null");
            return (Criteria) this;
        }

        public Criteria andDepidEqualTo(Integer value) {
            addCriterion("DepID =", value, "depid");
            return (Criteria) this;
        }

        public Criteria andDepidNotEqualTo(Integer value) {
            addCriterion("DepID <>", value, "depid");
            return (Criteria) this;
        }

        public Criteria andDepidGreaterThan(Integer value) {
            addCriterion("DepID >", value, "depid");
            return (Criteria) this;
        }

        public Criteria andDepidGreaterThanOrEqualTo(Integer value) {
            addCriterion("DepID >=", value, "depid");
            return (Criteria) this;
        }

        public Criteria andDepidLessThan(Integer value) {
            addCriterion("DepID <", value, "depid");
            return (Criteria) this;
        }

        public Criteria andDepidLessThanOrEqualTo(Integer value) {
            addCriterion("DepID <=", value, "depid");
            return (Criteria) this;
        }

        public Criteria andDepidIn(List<Integer> values) {
            addCriterion("DepID in", values, "depid");
            return (Criteria) this;
        }

        public Criteria andDepidNotIn(List<Integer> values) {
            addCriterion("DepID not in", values, "depid");
            return (Criteria) this;
        }

        public Criteria andDepidBetween(Integer value1, Integer value2) {
            addCriterion("DepID between", value1, value2, "depid");
            return (Criteria) this;
        }

        public Criteria andDepidNotBetween(Integer value1, Integer value2) {
            addCriterion("DepID not between", value1, value2, "depid");
            return (Criteria) this;
        }

        public Criteria andDepcodeIsNull() {
            addCriterion("DepCode is null");
            return (Criteria) this;
        }

        public Criteria andDepcodeIsNotNull() {
            addCriterion("DepCode is not null");
            return (Criteria) this;
        }

        public Criteria andDepcodeEqualTo(String value) {
            addCriterion("DepCode =", value, "depcode");
            return (Criteria) this;
        }

        public Criteria andDepcodeNotEqualTo(String value) {
            addCriterion("DepCode <>", value, "depcode");
            return (Criteria) this;
        }

        public Criteria andDepcodeGreaterThan(String value) {
            addCriterion("DepCode >", value, "depcode");
            return (Criteria) this;
        }

        public Criteria andDepcodeGreaterThanOrEqualTo(String value) {
            addCriterion("DepCode >=", value, "depcode");
            return (Criteria) this;
        }

        public Criteria andDepcodeLessThan(String value) {
            addCriterion("DepCode <", value, "depcode");
            return (Criteria) this;
        }

        public Criteria andDepcodeLessThanOrEqualTo(String value) {
            addCriterion("DepCode <=", value, "depcode");
            return (Criteria) this;
        }

        public Criteria andDepcodeLike(String value) {
            addCriterion("DepCode like", value, "depcode");
            return (Criteria) this;
        }

        public Criteria andDepcodeNotLike(String value) {
            addCriterion("DepCode not like", value, "depcode");
            return (Criteria) this;
        }

        public Criteria andDepcodeIn(List<String> values) {
            addCriterion("DepCode in", values, "depcode");
            return (Criteria) this;
        }

        public Criteria andDepcodeNotIn(List<String> values) {
            addCriterion("DepCode not in", values, "depcode");
            return (Criteria) this;
        }

        public Criteria andDepcodeBetween(String value1, String value2) {
            addCriterion("DepCode between", value1, value2, "depcode");
            return (Criteria) this;
        }

        public Criteria andDepcodeNotBetween(String value1, String value2) {
            addCriterion("DepCode not between", value1, value2, "depcode");
            return (Criteria) this;
        }

        public Criteria andCreateduseridIsNull() {
            addCriterion("CreatedUserID is null");
            return (Criteria) this;
        }

        public Criteria andCreateduseridIsNotNull() {
            addCriterion("CreatedUserID is not null");
            return (Criteria) this;
        }

        public Criteria andCreateduseridEqualTo(Integer value) {
            addCriterion("CreatedUserID =", value, "createduserid");
            return (Criteria) this;
        }

        public Criteria andCreateduseridNotEqualTo(Integer value) {
            addCriterion("CreatedUserID <>", value, "createduserid");
            return (Criteria) this;
        }

        public Criteria andCreateduseridGreaterThan(Integer value) {
            addCriterion("CreatedUserID >", value, "createduserid");
            return (Criteria) this;
        }

        public Criteria andCreateduseridGreaterThanOrEqualTo(Integer value) {
            addCriterion("CreatedUserID >=", value, "createduserid");
            return (Criteria) this;
        }

        public Criteria andCreateduseridLessThan(Integer value) {
            addCriterion("CreatedUserID <", value, "createduserid");
            return (Criteria) this;
        }

        public Criteria andCreateduseridLessThanOrEqualTo(Integer value) {
            addCriterion("CreatedUserID <=", value, "createduserid");
            return (Criteria) this;
        }

        public Criteria andCreateduseridIn(List<Integer> values) {
            addCriterion("CreatedUserID in", values, "createduserid");
            return (Criteria) this;
        }

        public Criteria andCreateduseridNotIn(List<Integer> values) {
            addCriterion("CreatedUserID not in", values, "createduserid");
            return (Criteria) this;
        }

        public Criteria andCreateduseridBetween(Integer value1, Integer value2) {
            addCriterion("CreatedUserID between", value1, value2, "createduserid");
            return (Criteria) this;
        }

        public Criteria andCreateduseridNotBetween(Integer value1, Integer value2) {
            addCriterion("CreatedUserID not between", value1, value2, "createduserid");
            return (Criteria) this;
        }

        public Criteria andCreateddatetimeIsNull() {
            addCriterion("CreatedDatetime is null");
            return (Criteria) this;
        }

        public Criteria andCreateddatetimeIsNotNull() {
            addCriterion("CreatedDatetime is not null");
            return (Criteria) this;
        }

        public Criteria andCreateddatetimeEqualTo(Date value) {
            addCriterion("CreatedDatetime =", value, "createddatetime");
            return (Criteria) this;
        }

        public Criteria andCreateddatetimeNotEqualTo(Date value) {
            addCriterion("CreatedDatetime <>", value, "createddatetime");
            return (Criteria) this;
        }

        public Criteria andCreateddatetimeGreaterThan(Date value) {
            addCriterion("CreatedDatetime >", value, "createddatetime");
            return (Criteria) this;
        }

        public Criteria andCreateddatetimeGreaterThanOrEqualTo(Date value) {
            addCriterion("CreatedDatetime >=", value, "createddatetime");
            return (Criteria) this;
        }

        public Criteria andCreateddatetimeLessThan(Date value) {
            addCriterion("CreatedDatetime <", value, "createddatetime");
            return (Criteria) this;
        }

        public Criteria andCreateddatetimeLessThanOrEqualTo(Date value) {
            addCriterion("CreatedDatetime <=", value, "createddatetime");
            return (Criteria) this;
        }

        public Criteria andCreateddatetimeIn(List<Date> values) {
            addCriterion("CreatedDatetime in", values, "createddatetime");
            return (Criteria) this;
        }

        public Criteria andCreateddatetimeNotIn(List<Date> values) {
            addCriterion("CreatedDatetime not in", values, "createddatetime");
            return (Criteria) this;
        }

        public Criteria andCreateddatetimeBetween(Date value1, Date value2) {
            addCriterion("CreatedDatetime between", value1, value2, "createddatetime");
            return (Criteria) this;
        }

        public Criteria andCreateddatetimeNotBetween(Date value1, Date value2) {
            addCriterion("CreatedDatetime not between", value1, value2, "createddatetime");
            return (Criteria) this;
        }

        public Criteria andLastupdateuseridIsNull() {
            addCriterion("LastUpdateUserID is null");
            return (Criteria) this;
        }

        public Criteria andLastupdateuseridIsNotNull() {
            addCriterion("LastUpdateUserID is not null");
            return (Criteria) this;
        }

        public Criteria andLastupdateuseridEqualTo(Integer value) {
            addCriterion("LastUpdateUserID =", value, "lastupdateuserid");
            return (Criteria) this;
        }

        public Criteria andLastupdateuseridNotEqualTo(Integer value) {
            addCriterion("LastUpdateUserID <>", value, "lastupdateuserid");
            return (Criteria) this;
        }

        public Criteria andLastupdateuseridGreaterThan(Integer value) {
            addCriterion("LastUpdateUserID >", value, "lastupdateuserid");
            return (Criteria) this;
        }

        public Criteria andLastupdateuseridGreaterThanOrEqualTo(Integer value) {
            addCriterion("LastUpdateUserID >=", value, "lastupdateuserid");
            return (Criteria) this;
        }

        public Criteria andLastupdateuseridLessThan(Integer value) {
            addCriterion("LastUpdateUserID <", value, "lastupdateuserid");
            return (Criteria) this;
        }

        public Criteria andLastupdateuseridLessThanOrEqualTo(Integer value) {
            addCriterion("LastUpdateUserID <=", value, "lastupdateuserid");
            return (Criteria) this;
        }

        public Criteria andLastupdateuseridIn(List<Integer> values) {
            addCriterion("LastUpdateUserID in", values, "lastupdateuserid");
            return (Criteria) this;
        }

        public Criteria andLastupdateuseridNotIn(List<Integer> values) {
            addCriterion("LastUpdateUserID not in", values, "lastupdateuserid");
            return (Criteria) this;
        }

        public Criteria andLastupdateuseridBetween(Integer value1, Integer value2) {
            addCriterion("LastUpdateUserID between", value1, value2, "lastupdateuserid");
            return (Criteria) this;
        }

        public Criteria andLastupdateuseridNotBetween(Integer value1, Integer value2) {
            addCriterion("LastUpdateUserID not between", value1, value2, "lastupdateuserid");
            return (Criteria) this;
        }

        public Criteria andLastupdatedatetimeIsNull() {
            addCriterion("LastUpdateDatetime is null");
            return (Criteria) this;
        }

        public Criteria andLastupdatedatetimeIsNotNull() {
            addCriterion("LastUpdateDatetime is not null");
            return (Criteria) this;
        }

        public Criteria andLastupdatedatetimeEqualTo(Date value) {
            addCriterion("LastUpdateDatetime =", value, "lastupdatedatetime");
            return (Criteria) this;
        }

        public Criteria andLastupdatedatetimeNotEqualTo(Date value) {
            addCriterion("LastUpdateDatetime <>", value, "lastupdatedatetime");
            return (Criteria) this;
        }

        public Criteria andLastupdatedatetimeGreaterThan(Date value) {
            addCriterion("LastUpdateDatetime >", value, "lastupdatedatetime");
            return (Criteria) this;
        }

        public Criteria andLastupdatedatetimeGreaterThanOrEqualTo(Date value) {
            addCriterion("LastUpdateDatetime >=", value, "lastupdatedatetime");
            return (Criteria) this;
        }

        public Criteria andLastupdatedatetimeLessThan(Date value) {
            addCriterion("LastUpdateDatetime <", value, "lastupdatedatetime");
            return (Criteria) this;
        }

        public Criteria andLastupdatedatetimeLessThanOrEqualTo(Date value) {
            addCriterion("LastUpdateDatetime <=", value, "lastupdatedatetime");
            return (Criteria) this;
        }

        public Criteria andLastupdatedatetimeIn(List<Date> values) {
            addCriterion("LastUpdateDatetime in", values, "lastupdatedatetime");
            return (Criteria) this;
        }

        public Criteria andLastupdatedatetimeNotIn(List<Date> values) {
            addCriterion("LastUpdateDatetime not in", values, "lastupdatedatetime");
            return (Criteria) this;
        }

        public Criteria andLastupdatedatetimeBetween(Date value1, Date value2) {
            addCriterion("LastUpdateDatetime between", value1, value2, "lastupdatedatetime");
            return (Criteria) this;
        }

        public Criteria andLastupdatedatetimeNotBetween(Date value1, Date value2) {
            addCriterion("LastUpdateDatetime not between", value1, value2, "lastupdatedatetime");
            return (Criteria) this;
        }

        public Criteria andDepnameIsNull() {
            addCriterion("DepName is null");
            return (Criteria) this;
        }

        public Criteria andDepnameIsNotNull() {
            addCriterion("DepName is not null");
            return (Criteria) this;
        }

        public Criteria andDepnameEqualTo(String value) {
            addCriterion("DepName =", value, "depname");
            return (Criteria) this;
        }

        public Criteria andDepnameNotEqualTo(String value) {
            addCriterion("DepName <>", value, "depname");
            return (Criteria) this;
        }

        public Criteria andDepnameGreaterThan(String value) {
            addCriterion("DepName >", value, "depname");
            return (Criteria) this;
        }

        public Criteria andDepnameGreaterThanOrEqualTo(String value) {
            addCriterion("DepName >=", value, "depname");
            return (Criteria) this;
        }

        public Criteria andDepnameLessThan(String value) {
            addCriterion("DepName <", value, "depname");
            return (Criteria) this;
        }

        public Criteria andDepnameLessThanOrEqualTo(String value) {
            addCriterion("DepName <=", value, "depname");
            return (Criteria) this;
        }

        public Criteria andDepnameLike(String value) {
            addCriterion("DepName like", value, "depname");
            return (Criteria) this;
        }

        public Criteria andDepnameNotLike(String value) {
            addCriterion("DepName not like", value, "depname");
            return (Criteria) this;
        }

        public Criteria andDepnameIn(List<String> values) {
            addCriterion("DepName in", values, "depname");
            return (Criteria) this;
        }

        public Criteria andDepnameNotIn(List<String> values) {
            addCriterion("DepName not in", values, "depname");
            return (Criteria) this;
        }

        public Criteria andDepnameBetween(String value1, String value2) {
            addCriterion("DepName between", value1, value2, "depname");
            return (Criteria) this;
        }

        public Criteria andDepnameNotBetween(String value1, String value2) {
            addCriterion("DepName not between", value1, value2, "depname");
            return (Criteria) this;
        }

        public Criteria andLanguagetypeIsNull() {
            addCriterion("LanguageType is null");
            return (Criteria) this;
        }

        public Criteria andLanguagetypeIsNotNull() {
            addCriterion("LanguageType is not null");
            return (Criteria) this;
        }

        public Criteria andLanguagetypeEqualTo(Integer value) {
            addCriterion("LanguageType =", value, "languagetype");
            return (Criteria) this;
        }

        public Criteria andLanguagetypeNotEqualTo(Integer value) {
            addCriterion("LanguageType <>", value, "languagetype");
            return (Criteria) this;
        }

        public Criteria andLanguagetypeGreaterThan(Integer value) {
            addCriterion("LanguageType >", value, "languagetype");
            return (Criteria) this;
        }

        public Criteria andLanguagetypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("LanguageType >=", value, "languagetype");
            return (Criteria) this;
        }

        public Criteria andLanguagetypeLessThan(Integer value) {
            addCriterion("LanguageType <", value, "languagetype");
            return (Criteria) this;
        }

        public Criteria andLanguagetypeLessThanOrEqualTo(Integer value) {
            addCriterion("LanguageType <=", value, "languagetype");
            return (Criteria) this;
        }

        public Criteria andLanguagetypeIn(List<Integer> values) {
            addCriterion("LanguageType in", values, "languagetype");
            return (Criteria) this;
        }

        public Criteria andLanguagetypeNotIn(List<Integer> values) {
            addCriterion("LanguageType not in", values, "languagetype");
            return (Criteria) this;
        }

        public Criteria andLanguagetypeBetween(Integer value1, Integer value2) {
            addCriterion("LanguageType between", value1, value2, "languagetype");
            return (Criteria) this;
        }

        public Criteria andLanguagetypeNotBetween(Integer value1, Integer value2) {
            addCriterion("LanguageType not between", value1, value2, "languagetype");
            return (Criteria) this;
        }

        public Criteria andParentidIsNull() {
            addCriterion("ParentID is null");
            return (Criteria) this;
        }

        public Criteria andParentidIsNotNull() {
            addCriterion("ParentID is not null");
            return (Criteria) this;
        }

        public Criteria andParentidEqualTo(Integer value) {
            addCriterion("ParentID =", value, "parentid");
            return (Criteria) this;
        }

        public Criteria andParentidNotEqualTo(Integer value) {
            addCriterion("ParentID <>", value, "parentid");
            return (Criteria) this;
        }

        public Criteria andParentidGreaterThan(Integer value) {
            addCriterion("ParentID >", value, "parentid");
            return (Criteria) this;
        }

        public Criteria andParentidGreaterThanOrEqualTo(Integer value) {
            addCriterion("ParentID >=", value, "parentid");
            return (Criteria) this;
        }

        public Criteria andParentidLessThan(Integer value) {
            addCriterion("ParentID <", value, "parentid");
            return (Criteria) this;
        }

        public Criteria andParentidLessThanOrEqualTo(Integer value) {
            addCriterion("ParentID <=", value, "parentid");
            return (Criteria) this;
        }

        public Criteria andParentidIn(List<Integer> values) {
            addCriterion("ParentID in", values, "parentid");
            return (Criteria) this;
        }

        public Criteria andParentidNotIn(List<Integer> values) {
            addCriterion("ParentID not in", values, "parentid");
            return (Criteria) this;
        }

        public Criteria andParentidBetween(Integer value1, Integer value2) {
            addCriterion("ParentID between", value1, value2, "parentid");
            return (Criteria) this;
        }

        public Criteria andParentidNotBetween(Integer value1, Integer value2) {
            addCriterion("ParentID not between", value1, value2, "parentid");
            return (Criteria) this;
        }

        public Criteria andIsdeletedIsNull() {
            addCriterion("IsDeleted is null");
            return (Criteria) this;
        }

        public Criteria andIsdeletedIsNotNull() {
            addCriterion("IsDeleted is not null");
            return (Criteria) this;
        }

        public Criteria andIsdeletedEqualTo(Boolean value) {
            addCriterion("IsDeleted =", value, "isdeleted");
            return (Criteria) this;
        }

        public Criteria andIsdeletedNotEqualTo(Boolean value) {
            addCriterion("IsDeleted <>", value, "isdeleted");
            return (Criteria) this;
        }

        public Criteria andIsdeletedGreaterThan(Boolean value) {
            addCriterion("IsDeleted >", value, "isdeleted");
            return (Criteria) this;
        }

        public Criteria andIsdeletedGreaterThanOrEqualTo(Boolean value) {
            addCriterion("IsDeleted >=", value, "isdeleted");
            return (Criteria) this;
        }

        public Criteria andIsdeletedLessThan(Boolean value) {
            addCriterion("IsDeleted <", value, "isdeleted");
            return (Criteria) this;
        }

        public Criteria andIsdeletedLessThanOrEqualTo(Boolean value) {
            addCriterion("IsDeleted <=", value, "isdeleted");
            return (Criteria) this;
        }

        public Criteria andIsdeletedIn(List<Boolean> values) {
            addCriterion("IsDeleted in", values, "isdeleted");
            return (Criteria) this;
        }

        public Criteria andIsdeletedNotIn(List<Boolean> values) {
            addCriterion("IsDeleted not in", values, "isdeleted");
            return (Criteria) this;
        }

        public Criteria andIsdeletedBetween(Boolean value1, Boolean value2) {
            addCriterion("IsDeleted between", value1, value2, "isdeleted");
            return (Criteria) this;
        }

        public Criteria andIsdeletedNotBetween(Boolean value1, Boolean value2) {
            addCriterion("IsDeleted not between", value1, value2, "isdeleted");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}